Attribute VB_Name = "Module1"
Option Explicit

Private Function ProfitLoss(ByVal Direction As String, ByVal Symbol As String, ByVal Units As Long, ByVal OpenPrice As Currency, ByVal ClosePrice As Currency, ByRef PL As Currency) As Boolean
    
    Dim Index As Integer
    Dim Pips As Currency
    Dim CrossUSDRate As Currency
    
    Dim OpenAmount As Long
    Dim CloseAmount As Long
    Dim ResultAmount As Long
    
    If (OpenPrice > 0 And ClosePrice > 0) Then
    
    
        Select Case Symbol
    
            Case "EURUSD"
                
                
                Pips = ClosePrice - OpenPrice
                If (Pips < 0) Then
                    If (Direction = "S") Then
                        Pips = Abs(Pips)
                    End If
                Else
                    If (Direction = "S") Then
                        Pips = -Pips
                    End If
                End If
                
                PL = Pips * Units
                
                ProfitLoss = True
               

            Case "AUDUSD"

                Pips = ClosePrice - OpenPrice
                If (Pips < 0) Then
                    If (Direction = "S") Then
                        Pips = Abs(Pips)
                    End If
                Else
                    If (Direction = "S") Then
                        Pips = -Pips
                    End If
                End If
                
                PL = Pips * Units
                
                ProfitLoss = True
               
            
            Case "NZDUSD"

                Pips = ClosePrice - OpenPrice
                If (Pips < 0) Then
                    If (Direction = "S") Then
                        Pips = Abs(Pips)
                    End If
                Else
                    If (Direction = "S") Then
                        Pips = -Pips
                    End If
                End If
                
                PL = Pips * Units
                
                ProfitLoss = True
              
                
            Case "USDJPY"

                '1. Value of the postion at the open price:
                'Buy 1 unit of USD/JPY at 111.00
                '100,000 USD (1 Unit) x 111.00 = 11100000 Yen

                '2. Value of the position at the close price:
                'Sell 1 unit of USD/JPY at 111.05
                '100,000 USD (1 Unit) x 111.05 = 11105000 Yen

                '3. P/L in Yen:
                '11105000 - 11100000 = 5000 Yen

                '4. Convert the P/L into USD, using the current USD/JPY rate:
                '5000/111.05 = $45.02
                
                
                OpenAmount = Units * OpenPrice
                CloseAmount = Units * ClosePrice
                ResultAmount = CloseAmount - OpenAmount
                
                If (ResultAmount < 0) Then
                    If (Direction = "S") Then
                        ResultAmount = Abs(ResultAmount)
                    End If
                Else
                    If (Direction = "S") Then
                        ResultAmount = -ResultAmount
                    End If
                End If
                
                PL = ResultAmount / ClosePrice
               
                ProfitLoss = True
                
            Case "USDCAD"
                
                
                
                OpenAmount = Units * OpenPrice
                CloseAmount = Units * ClosePrice
                ResultAmount = CloseAmount - OpenAmount
                
                If (ResultAmount < 0) Then
                    If (Direction = "S") Then
                        ResultAmount = Abs(ResultAmount)
                    End If
                Else
                    If (Direction = "S") Then
                        ResultAmount = -ResultAmount
                    End If
                End If
                
                PL = ResultAmount / ClosePrice
               
                ProfitLoss = True
                
            Case "AUDJPY"

                'If a trader Buys 1 unit of AUD/JPY at 72.13 and closes the position at 72.20, the P/L will be calculated as follows:

                'Value of the position at the opening price of 72.13 = 100,000 x 72.13 = 7,213,000 Yen

                'Value of the position at the closing price of 72.20 = 100,000 x 72.20 = 7,220,000 Yen

                'P/L in Yen = 7,220,000 - 7,213,000 = 7,000 Yen

                'USD/JPY (ASK rate) at the time of closure = 120.36

                'P/L in US dollars: 7,000 JPY / 120.36 = $58.16
                
                'CrossUSDRate = "USDJPY"
                For Index = 1 To 11
                    If (Symbols(Index, 0) = "USDJPY") Then
                        CrossUSDRate = CCur(Symbols(Index, 1))
                        Exit For
                    End If
                Next
                
                If (CrossUSDRate > 0) Then

                    OpenAmount = Units * OpenPrice
                    CloseAmount = Units * ClosePrice
                    ResultAmount = CloseAmount - OpenAmount
                
                    If (ResultAmount < 0) Then
                        If (Direction = "S") Then
                            ResultAmount = Abs(ResultAmount)
                        End If
                    Else
                        If (Direction = "S") Then
                            ResultAmount = -ResultAmount
                        End If
                    End If
                
                    PL = ResultAmount / CrossUSDRate
                
                    ProfitLoss = True
                
                Else
                    PL = 0
                    ProfitLoss = False
                End If

            Case "EURJPY"
                
                'CrossUSDRate = "USDJPY"
                For Index = 1 To 11
                    If (Symbols(Index, 0) = "USDJPY") Then
                        CrossUSDRate = CCur(Symbols(Index, 1))
                        Exit For
                    End If
                Next
                
                If (CrossUSDRate > 0) Then
                
                    OpenAmount = Units * OpenPrice
                    CloseAmount = Units * ClosePrice
                    ResultAmount = CloseAmount - OpenAmount
                
                    If (ResultAmount < 0) Then
                        If (Direction = "S") Then
                            ResultAmount = Abs(ResultAmount)
                        End If
                    Else
                        If (Direction = "S") Then
                            ResultAmount = -ResultAmount
                        End If
                    End If
                
                    PL = ResultAmount / CrossUSDRate
                
                    ProfitLoss = True
                
                Else
                    PL = 0
                    ProfitLoss = False
                End If
                
            Case "NZDJPY"
                
                'CrossUSDRate = "USDJPY"
                For Index = 1 To 11
                    If (Symbols(Index, 0) = "USDJPY") Then
                        CrossUSDRate = CCur(Symbols(Index, 1))
                        Exit For
                    End If
                Next
                
                If (CrossUSDRate > 0) Then
                
                    OpenAmount = Units * OpenPrice
                    CloseAmount = Units * ClosePrice
                    ResultAmount = CloseAmount - OpenAmount
                
                    If (ResultAmount < 0) Then
                        If (Direction = "S") Then
                            ResultAmount = Abs(ResultAmount)
                        End If
                    Else
                        If (Direction = "S") Then
                            ResultAmount = -ResultAmount
                        End If
                    End If
                
                    PL = ResultAmount / CrossUSDRate
                
                    ProfitLoss = True
                
                Else
                    PL = 0
                    ProfitLoss = False
                End If
                
            Case "CADJPY"
                
                'CrossUSDRate = "USDJPY"
                For Index = 1 To 11
                    If (Symbols(Index, 0) = "USDJPY") Then
                        CrossUSDRate = CCur(Symbols(Index, 1))
                        Exit For
                    End If
                Next
                
                If (CrossUSDRate > 0) Then
                
                    OpenAmount = Units * OpenPrice
                    CloseAmount = Units * ClosePrice
                    ResultAmount = CloseAmount - OpenAmount
                
                    If (ResultAmount < 0) Then
                        If (Direction = "S") Then
                            ResultAmount = Abs(ResultAmount)
                        End If
                    Else
                        If (Direction = "S") Then
                            ResultAmount = -ResultAmount
                        End If
                    End If
                
                    PL = ResultAmount / CrossUSDRate
                
                    ProfitLoss = True
                
                Else
                    PL = 0
                    ProfitLoss = False
                End If
                
            Case "EURAUD"
                
                'CrossUSDRate = "AUDUSD"
                For Index = 1 To 11
                    If (Symbols(Index, 0) = "AUDUSD") Then
                        CrossUSDRate = CCur(Symbols(Index, 1))
                        Exit For
                    End If
                Next
                
                If (CrossUSDRate > 0) Then
                
                    OpenAmount = Units * OpenPrice
                    CloseAmount = Units * ClosePrice
                    ResultAmount = CloseAmount - OpenAmount
                
                    If (ResultAmount < 0) Then
                        If (Direction = "S") Then
                            ResultAmount = Abs(ResultAmount)
                        End If
                    Else
                        If (Direction = "S") Then
                            ResultAmount = -ResultAmount
                        End If
                    End If
                
                    PL = ResultAmount / (1 / CrossUSDRate)  'Reverse this rate to get USD
                
                    ProfitLoss = True
                
                Else
                    PL = 0
                    ProfitLoss = False
                End If
                
            Case "EURCAD"
                
                'CrossUSDRate = "USDCAD"
                For Index = 1 To 11
                    If (Symbols(Index, 0) = "USDCAD") Then
                        CrossUSDRate = CCur(Symbols(Index, 1))
                        Exit For
                    End If
                Next
                
                If (CrossUSDRate > 0) Then
                
                    OpenAmount = Units * OpenPrice
                    CloseAmount = Units * ClosePrice
                    ResultAmount = CloseAmount - OpenAmount
                
                    If (ResultAmount < 0) Then
                        If (Direction = "S") Then
                            ResultAmount = Abs(ResultAmount)
                        End If
                    Else
                        If (Direction = "S") Then
                            ResultAmount = -ResultAmount
                        End If
                    End If
                
                    PL = ResultAmount / CrossUSDRate
                
                    ProfitLoss = True
                
                Else
                    PL = 0
                    ProfitLoss = False
                End If
                
        End Select
        
        
    
    Else
        PL = 0
        ProfitLoss = False
    End If
    
    
    
    
End Function
